#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>
#include "buttons.h"
#include <math.h>

unsigned char Buttons = 0;
int input;

/******************************************************************************************
*
*	Function name : CheckButtons
*
*	Returns :	    Input from user on the STK500-Buttons    	
*
*	Parameters :	none
*
*	Purpose :		Check if any input from the Buttons
*
******************************************************************************************/
void CheckButtons(void)
{
    unsigned char Temp_buttons;
    
    Temp_buttons = ~PINE;               // read PINE, 
    Temp_buttons &= 0xFF; // mask away other bits (actually doesnt mask any bits with 0xFF)
    
	input =0;
	
    // if anything applied on the buttons, and that differs from the last time
    if(Temp_buttons && (Temp_buttons != Buttons)) 
    {  
        Buttons = Temp_buttons; // load the temporary stored buttons to the global Buttons
    
        if(Buttons == Button1)  // if Button1 is pressed
        {
           input = 1;
        }
        
		else if(Buttons == Button2)   // if Button2 is pressed
        {
           input = 2;
        }
 
		else if(Buttons == Button3)   // if Button3 is pressed
        {
           input = 3;
        }

		else if(Buttons == Button4)   // if Button4 is pressed
        {
           input = 4;
        }
		       
		else if(Buttons == Button5)   // if Button5 is pressed
        {
           input = 5;
        }
		
		else if(Buttons == Button6)   // if Button6 is pressed
        {
           input = 6;
        }
 
		else if(Buttons == Button7)   // if Button7 is pressed
        {
           input = 7;
        }
		
		else if(Buttons == Button8)   // if Button8 is pressed
        {
           input = 8;
        }
 	
    }
    else
        Buttons = Temp_buttons;     // load the input on PINE to the global Buttons
}
