#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>
#include "switches.h"
#include <math.h>

unsigned char Switches = 0;
int input_switch;

/******************************************************************************************
*
*	Function name : CheckSwitches
*
*	Returns :	    input_switch from user on the STK500-Switches    	
*
*	Parameters :	none
*
*	Purpose :		Check if any input_switch from the Switches
*
******************************************************************************************/
void CheckSwitches(void)
{
    unsigned char Temp_switches;
    
    Temp_switches = ~PIND;               // read PIND, 
   // Temp_switches &= 0xFF; // mask away other bits (actually doesnt mask any bits when using 0xFF)
    
	input_switch = 0;
	
    // if anything applied on the switches, and that differs from the last time
    if(Temp_switches)
    {  
        Switches = Temp_switches; // load the temporary stored switches to the global Switches
    
        if(Switches == Switch1)  // if Switch1 is pressed
        {
           input_switch = 1;
        }
        
		else if(Switches == Switch2)   // if Switch2 is pressed
        {
           input_switch = 2;
        }
 
		else if(Switches == Switch3)   // if Switch3 is pressed
        {
           input_switch = 3;
        }

		else if(Switches == Switch4)   // if Switch4 is pressed
        {
           input_switch = 4;
        }
		       
		else if(Switches == Switch5)   // if Switch5 is pressed
        {
           input_switch = 5;
        }
		
		else if(Switches == Switch6)   // if Switch6 is pressed
        {
           input_switch = 6;
        }
 
		else if(Switches == Switch7)   // if Switch7 is pressed
        {
           input_switch = 7;
        }
		
		else if(Switches == Switch8)   // if Switch8 is pressed
        {
           input_switch = 8;
        }
 	
		else if(Switches == Switch87)   // if Switch8 and Switch6 is pressed
        {
           input_switch = 87;
        }
		
		else if(Switches == Switch86)   // if Switch8 and Switch5 is pressed
        {
           input_switch = 86;
        }
 	
		else if(Switches == Switch85)   // if Switch8 and Switch6 is pressed
        {
           input_switch = 85;
        }
		
		else if(Switches == Switch76)   // if Switch8 and Switch5 is pressed
        {
           input_switch = 76;
        }
	
		else if(Switches == Switch75)   // if Switch8 and Switch5 is pressed
        {
           input_switch = 75;
        }
	
		else if(Switches == Switch65)   // if Switch8 and Switch5 is pressed
        {
           input_switch = 65;
        }
		
    }
    else
	
        Switches = Temp_switches;     // load the input_switch on PINE to the global Switches
}
