
/*
   Filename:  Main.c
   
*/

#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <stdio.h>
#include "lcd.h"
#include "Temperature.h"
#include "Buttons.h"

extern void RTC_init(void);
extern void convert_time(void);

//Declared in this file Main.c//////////////////////////////////////////
long int second,min,hr,day,month,year_lo,year_hi, hrd, delays, delaysa;

long int set_point, change, changeb;
float TEMP_HIGHBYTE, TEMP_LOWBYTE, targettemp;

void main_screen(void);
void choose_menu(void);
void Temperature_reg(void);
void System_status(void);
void change_target_temp(void);


unsigned char output_string[10];
unsigned char timeday[10],status[10],mode[10],dayDisplay[4],am[3];
unsigned char led;

unsigned char Temp;

int pgmnum;
int military = 1;
int counter = 0;
int heat = 0, cool = 0, off = 0, fan = 0;
////////////////////////////////////////////////////////////////////////


//Declared in Temperature.c///
extern float Temperature;
extern int ADCresult_average;
extern void ADC_conversion(void);
extern void Temp_calculation(int);
///////////////////////////////////

//Declared in Switches.c/////
extern unsigned char inreg;
extern long int program_mode;
extern void switches(void);
extern void output(void);
/////////////////////////////


//Declared in CheckButtons.c///
extern int input;
extern void CheckButtons(void);
////////////////////////////////

//Delcared in CheckSwitches.c//
extern int input_switch;
extern void CheckSwitches(void);
/////////////////////////////////

//Declared in Reset_menu.c///
extern void reset_menu(void);
extern long int maxtemp, mintemp, dayw;
/////////////////////////////

//Declared in Program_menu.c///
extern void program_menu(void);
extern long int temppgmnum;
extern long int tpgmhr1, tpgmmin1, tpgmhr2,  tpgmmin2;
extern long int tpgmhr3,  tpgmmin3,  tpgmhr4, tpgmmin4;
extern long int tpgmtemp1, tpgmtemp2, tpgmtemp3, tpgmtemp4;
extern long int pgm1hr1, pgm1hr2, pgm1hr3, pgm1hr4;
extern long int pgm2hr1, pgm2hr2, pgm2hr3, pgm2hr4;
extern long int pgm3hr1, pgm3hr2, pgm3hr3, pgm3hr4;
extern long int pgm1min1, pgm1min2, pgm1min3, pgm1min4;
extern long int pgm2min1, pgm2min2, pgm2min3, pgm2min4;
extern long int pgm3min1, pgm3min2, pgm3min3, pgm3min4;
extern long int pgm1temp1, pgm1temp2, pgm1temp3, pgm1temp4;
extern long int pgm2temp1, pgm2temp2, pgm2temp3, pgm2temp4;
extern long int pgm3temp1, pgm3temp2, pgm3temp3, pgm3temp4;
extern short int pgm1wkday, pgm2wkday, pgm3wkday, pgm1sun, pgm2sun, pgm3sun;
/////////////////////////////////

///Declared in Set_switches.c//
extern void set_switches();
//////////////////////////////

//Declared in Program_run////
extern long int pgmsun, pgmsat, pgmwk, pgmwkday, pgmtemp1, pgmtemp2, pgmtemp3, pgmtemp4;
extern long int pgmhr1,pgmmin1,pgmhr2,pgmmin2,pgmhr3,pgmmin3,pgmhr4,pgmmin4;
///////////////////////

//For LEDs///////////////////
typedef unsigned char  u08;
/////////////////////////////





int main( void )
{
	hr=12;
	min=0;
	//input=0;
	dayw=2;
	second=0;
	targettemp = 70;
	maxtemp = 95;
	mintemp = 40;
	temppgmnum = 1;
	tpgmhr1 = 2;
	tpgmmin1 = 0;
	tpgmhr2 = 2;
	tpgmmin2 =0;
	tpgmhr3 =2 ;
	tpgmmin3 = 0;
	input = 0;
	tpgmhr4 = 2;
	tpgmmin4 = 0;
	tpgmtemp1 = 70;
	tpgmtemp2 = 70;
	tpgmtemp3 = 70;
	tpgmtemp4 = 70;
	pgmsun = 1; 
	pgmsat=1;
	pgmwk=1;
    pgmtemp1=65; 
	pgmtemp2=84; 
	pgmtemp3=56; 
	pgmtemp4=78;
	pgm1hr1 = 12;
	pgm1hr2 = 12;
	pgm1hr3 = 12;
	pgm1hr4 = 12;
	pgm1min1 = 11;
	pgm1min2 = 12;
	pgm1min3 = 13;
	pgm1min4 = 14;
	pgm1temp1 = 71;
	pgm1temp2 = 72;
	pgm1temp3 = 73;
	pgm1temp4 = 74;
	pgm2hr1 = 12;
	pgm2hr2 = 12;
	pgm2hr3 = 12;
	pgm2hr4 = 12;
	pgm2min1 = 16;
	pgm2min2 = 17;
	pgm2min3 = 18;
	pgm2min4 = 19;
	pgm2temp1 = 75;
	pgm2temp2 = 76;
	pgm2temp3 = 77;
	pgm2temp4 = 78;
	pgm3hr1 = 12;
	pgm3hr2 = 12;
	pgm3hr3 = 12;
	pgm3hr4 = 12;
	pgm3min1 = 21;
	pgm3min2 = 22;
	pgm3min3 = 23;
	pgm3min4 = 24;
	pgm3temp1 = 79;
	pgm3temp2 = 80;
	pgm3temp3 = 81;
	pgm3temp4 = 82;



	cli(); //disables all interrupts globally, nothing will stop what is about to happen

	lcd_init(LCD_DISP_ON); //apg Initializes the LCD and turns the display on
	lcd_clrscr();	//Clears the lcd screen

	RTC_init();		//Our clock uses Timer0 for the real time clock
	
	PWM_init();                 // initialize Timer1 with PWM    
	
	// Select either Single Ended or Differential ADC measurement, comment out the other
    ADC_init(SingleEnded);     // initialize the ADC, select "Single_ended" or "Differential"
	//    ADC_init(Differential);     // initialize the ADC, select "Single_ended" or "Differential"

	///Setup outputs to LEDs/////
	outp(0x07, DDRB);      /* use PortD for output (LEDs) */
	//outp(0x00, DDRB);
	/////////////////////////////
	
	
	sei(); //enables all global interrupts

	strcpy(timeday, "PM");
	strcpy(status, "HEAT");
	strcpy(mode, "AUTO");
	strcpy(dayDisplay, "MON");
	
	pgmnum = 1;

	while (1)
	{
		CheckButtons();
		
		//CheckSwitches();
		
		convert_time();  //Changes seconds to minutes etc.
		
		ADC_conversion(); //Checks Thermistor
		
		main_screen();
		
//		Temperature_reg();
		
		//System_status();
	
		//set_switches();
		
		switches();
		
		choose_menu();
		
		counter++;
		
		
	}

	
}


void main_screen(void)
{

	/*
		lcd_puts("HEAT AUTO 1  MON\n");
		//lcd_puts(" 62 F    12:00 AM\n");	
		
	*/
/*	
	if (fan == 1)
	{
		strcpy(mode, "ON  ");
	}
	
	else if (fan == 0)
	{
		strcpy(mode, "AUTO");
	}
	
	if (heat == 1)
	{
		strcpy(status, "HEAT");
	}
	else if (off == 1)
	{
		strcpy(status, "OFF ");
	}
	else if (cool == 1)
	{
		strcpy(status, "COOL");
	}
*/	
	
	
	
	    ////Top Line of the Display//////
		lcd_puts(status);
		lcd_puts(" ");
		lcd_puts(mode);
		lcd_puts(" ");
		sprintf(output_string, "%1d", pgmnum);
		lcd_puts(output_string);
		lcd_puts("  ");
		lcd_puts(dayDisplay);
		lcd_puts("\n");
		/////////////////////////////////
	
	if(military == 1)
	{	
		/////Bottom Line of the Display/////
		sprintf(output_string, "%03.0f",(double)Temperature);  //%02.0f is 2 spaces to display a float with leading zeros and no digits after the decimal 
		lcd_puts(output_string);
		sprintf(output_string, "%03.0f",(double)targettemp);
		lcd_puts(output_string);
		sprintf(output_string, "  %2ld", hrd); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", min);  	// %02ld is 2 spaces to display a long int with leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", second);
		lcd_puts(output_string);
		//lcd_puts(" ");
		//lcd_puts(timeday);
		lcd_puts("\n");
		/////////////////////////////////////
	}
	
	else if(military == 0)
	{
		/////Bottom Line of the Display/////
		sprintf(output_string, "%03.0f",(double)Temperature);  //%02.0f is 2 spaces to display a float with leading zeros and no digits after the decimal 
		lcd_puts(output_string);
		sprintf(output_string, "  %2ld", hrd); 		// %2ld is 2 spaces to display a long int with no leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", min);  	// %02ld is 2 spaces to display a long int with leading zeros
		lcd_puts(output_string);
		lcd_puts(":");
		sprintf(output_string, "%02ld", second);
		lcd_puts(output_string);
		//lcd_puts(am);
		lcd_puts(" ");
		lcd_puts(timeday);
		lcd_puts("\n");
	}
	
	return;
		
}

void choose_menu(void)
{

	/*
	PIND |= ~PIND;
		
		lcd_clrscr();
		while (1)
		{
		
			if ( PIND7 & 1 )
			{
				lcd_puts("PIN 0 is on\n\n");
			}
			
			else
			{
				lcd_puts("PIN 0 is off\n\n");
			}
			
			~PIND;
		
			
		}
	
	*/
	
	
	if(input == 1||input == 2)
	{
		if(program_mode == 0)
		{
			change = input;
			change_target_temp();
		}
	}
	
	
	else if (input == 5)
	{
		reset_menu();
	}
	

	return;

}

/*
void System_status(void)
{
	
	if(input_switch == 8) 
	{
		heat = 0;
		cool = 1;
		off = 0;
		
		strcpy(status, "COOL");
		
	}
	
	
	else if (input_switch == 7)
	{
		heat = 1;
		cool = 0;
		off = 0;
		
		strcpy(status, "HEAT");
	}
	
	
	if (input_switch != 8 && input_switch != 7)
	{
		heat = 0;
		cool = 0;
		off = 1;
		
		strcpy(status, "OFF ");
	}
	
	
	return;

}
*/

void change_target_temp(void)
{
	lcd_clrscr();
	delays = second;
	delaysa = delays + 3;
	
	while (delays < delaysa)
	{

	delays = second;

	if(change == 1||input == 1)
	{
		targettemp++;
		
		if(targettemp > maxtemp)
		{
			targettemp = maxtemp;
		}
		
		changeb = 0;
	}
	else if(change ==2||input == 2)
	{
		targettemp--;
		
		if(targettemp < mintemp)
		{
			targettemp = mintemp;
		}
		
		changeb = 0;
	}
	else if(input == 0 && changeb == 0)
	{
		delaysa = delays + 3;
		changeb = 1;
	}
	
	change =0;

	lcd_puts("Target Temp:\n");
	sprintf(output_string, "%03.0f", (double)targettemp);
	lcd_puts(output_string);
	lcd_puts("\n");
	
	CheckButtons();
	
	}
	
	return;
}

void Temperature_reg(void)
{

	if(Temperature < (targettemp - 1))
	{
		heat = 1;
		cool = 0;
		fan = 1;
	}
	
	else if(Temperature > (targettemp + 1))
	{
		heat = 0;
		cool = 1;
		fan = 1;
	}
	
	else
	{
		heat = 0;
		cool = 0;
		fan = 0;
	}
	
	output();

	return;
}

