//*****************************************************************************
//
//  File........: Temperature.h
//
//*****************************************************************************

// Function declarations
    void ADC_init (unsigned char);          //initialize the ADC
    void PWM_init (void);                   //initialize Timer Counter 1
    void ADC_conversion (void);             //do a ADC_conversion, either differential or single-ended
    void Temp_calculation (int);            //calculate the temperature from the ADC-measurement
    void Temperature_regulation (void);     //"regulate" the temperature by setting heating or cooling LED/pin



/************************************************************************     
*                          
*                 Vref = 1.263V                                                 
*                 _____                                                     
*                   |                                                   
*                   |
*                 -----   
*                 |   |
*                 |   |  R_1 = 10 Kohm
*                 |   |
*                 -----
*                   | 
*                   |---------------------X    ADC channel #0 
*                   | 
*                 -----
*                 |   |
*                 |   |  R_NTC = ? ohm   (10Kohm @ 25 degree celcius)
*                 |   |
*                 -----
*                   |
*                   |---------------------X    ADC channel #1
*                   |
*                   |
*                  ---  
*                   - 
*                  GND
*                   
************************************************************************/  

// Defines
    #define V_ref           1.263       // voltage-reference 

// NTC-thermistor defines
    #define Beta            3450.000    // the Beta-value for the NTC transitor
    #define R_th            10000.00    // the thermistor resistans @ 25 degree Celsius
    #define T_amb           298.0000    // the temperature in Kelvin for 25 degree Celsius
    #define T_zero          273.0000    // the temperature in Kelvin for 0 degree Celsius


    #define SingleEnded     0x00        
    #define Differential    0x10        
    #define Heater          0x7F        
    #define Cooler          0xEF 
	
	
	#define __E				2.718  // APG This is to take care of error and i think that it should be a 10 for the math....



