#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>

void program_run(void);
void setvar(void);
void gettemp(void);

extern int pgmnum;
extern long int dayw;
extern long int hr, min;
extern long int pgm1hr1, pgm1hr2, pgm1hr3, pgm1hr4;
extern long int pgm2hr1, pgm2hr2, pgm2hr3, pgm2hr4;
extern long int pgm3hr1, pgm3hr2, pgm3hr3, pgm3hr4;
extern long int pgm1min1, pgm1min2, pgm1min3, pgm1min4;
extern long int pgm2min1, pgm2min2, pgm2min3, pgm2min4;
extern long int pgm3min1, pgm3min2, pgm3min3, pgm3min4;
extern long int pgm1temp1, pgm1temp2, pgm1temp3, pgm1temp4;
extern long int pgm2temp1, pgm2temp2, pgm2temp3, pgm2temp4;
extern long int pgm3temp1, pgm3temp2, pgm3temp3, pgm3temp4;
extern short int pgm1wkday, pgm2wkday, pgm3wkday, pgm1sun, pgm2sun, pgm3sun;
extern short int pgm1sat, pgm2sat, pgm3sat;

extern float targettemp;
 short int pgmsun, pgmsat, pgmwk;
 long int pgmtemp1, pgmtemp2, pgmtemp3, pgmtemp4;
 long int pgmhr1,pgmmin1,pgmhr2,pgmmin2,pgmhr3,pgmmin3,pgmhr4,pgmmin4;


void program_run(void)
{
	setvar();
//	targettemp = 85;
//	gettemp();


	if(dayw ==	2|| dayw == 3 || dayw == 4	|| dayw == 5 || dayw == 6)
	{
		if(pgmwk==1)
		{
			gettemp();
		}
		
		else
		{
			return;
		}
	}
	
	else if(dayw == 1)
	{
		if(pgmsun == 1)
		{
			gettemp();
		}
		
		else
		{
			return;
		}
	}
	
	else if(dayw == 7)
	{
		if(pgmsat == 1)
		{
			gettemp();
		}
		
		else
		{
			return;
		}
	}

	return;
}


/* setvar is a subroutine that sets the actual pgmtemps */
void setvar(void)
{
	if(pgmnum == 1)
	{
		pgmtemp1   = pgm1temp1;
		pgmtemp2   = pgm1temp2;
		pgmtemp3   = pgm1temp3;
		pgmtemp4   = pgm1temp4;
		pgmhr1     = pgm1hr1;
		pgmmin1    = pgm1min1;
		pgmhr2     = pgm1hr2;
		pgmmin2    = pgm1min2;
		pgmhr3     = pgm1hr3;
		pgmmin3    = pgm1min3;
		pgmhr4     = pgm1hr4;
		pgmmin4    = pgm1min4;
		pgmwk      = pgm1wkday;
		pgmsat	   = pgm1sat;
		pgmsun	   = pgm1sun;
	}

	else if(pgmnum == 2)
	{
		pgmtemp1   = pgm2temp1;
		pgmtemp2   = pgm2temp2;
		pgmtemp3   = pgm2temp3;
		pgmtemp4   = pgm2temp4;
		pgmhr1     = pgm2hr1;
		pgmmin1    = pgm2min1;
		pgmhr2     = pgm2hr2;
		pgmmin2    = pgm2min2;
		pgmhr3     = pgm2hr3;
		pgmmin3    = pgm2min3;
		pgmhr4     = pgm2hr4;
		pgmmin4    = pgm2min4;
		pgmwk      = pgm2wkday;
		pgmsat	   = pgm2sat;
		pgmsun	   = pgm2sun;
	}
	
	else if(pgmnum == 3)
	{
		pgmtemp1   = pgm3temp1;
		pgmtemp2   = pgm3temp2;
		pgmtemp3   = pgm3temp3;
		pgmtemp4   = pgm3temp4;
		pgmhr1     = pgm3hr1;
		pgmmin1    = pgm3min1;
		pgmhr2     = pgm3hr2;
		pgmmin2    = pgm3min2;
		pgmhr3     = pgm3hr3;
		pgmmin3    = pgm3min3;
		pgmhr4     = pgm3hr4;
		pgmmin4    = pgm3min4;
		pgmwk      = pgm3wkday;
		pgmsat	   = pgm3sat;
		pgmsun	   = pgm3sun;
	}
	
	return;
}

/* gettemp is a subroutine that gets the appropriate pgmtemp */

void gettemp (void){

	if(hr < pgmhr1)
	{
	  targettemp = pgmtemp4;
	  Temperature_reg();
	}

	else if(hr == pgmhr1 && min < pgmmin1)
	{
		targettemp = pgmtemp4;
		Temperature_reg();
	}
	
	else if(hr == pgmhr1 && min == pgmmin1)
	{
		targettemp = pgmtemp1;
		Temperature_reg();
	}
	
	else if(hr < pgmhr2)
	{
		targettemp = pgmtemp1;
		Temperature_reg();
	}
	
	else if(hr == pgmhr2 && min < pgmmin2)
	{
		targettemp = pgmtemp1;
		Temperature_reg();
	}
	
	else if(hr == pgmhr2 && min == pgmmin2)
	{
		targettemp = pgmtemp2;
		Temperature_reg();
	}

	else if(hr < pgmhr3)
	{
		targettemp = pgmtemp2;
		Temperature_reg();
	}
	
	else if(hr == pgmhr3 && min < pgmmin3)
	{
		targettemp = pgmtemp2;
		Temperature_reg();
	}
	
	else if(hr == pgmhr3 && min == pgmmin3)
	{
		targettemp = pgmtemp3;
		Temperature_reg();
	}
	
	else if(hr < pgmhr4)
	{
		targettemp = pgmtemp3;
		Temperature_reg();
	}
	
	else if(hr == pgmhr4 && min < pgmmin4)
	{
		targettemp = pgmtemp3;
		Temperature_reg();
	}
	
	else if(hr == pgmhr4 && min == pgmmin4)
	{
		targettemp = pgmtemp4;
		Temperature_reg();
	}

	else if(hr == pgmhr4 && min > pgmmin4)
	{
		targettemp = pgmtemp4;
		Temperature_reg();
	}
	
	else if(hr > pgmhr4)
	{
		targettemp = pgmtemp4;
		Temperature_reg();
	}
	
	return;
}