 /*
	This program copies the value of the input port to a variable. The variable is then check to decide
	how the variables should be set or what action to take. The following is a table of the possible inputs.

	Table of values for inputs
	 fan 	pgm 	pgm #	system 	  hex
			mode			mode	 value
	00	 	00 		00 		00 		= 0x00
	00 		00 		00 		01 		= 0x01
	00 		00 		00 		10 		= 0x02
	00 		00 		01 		00 		= 0x04
	00 		00 		01 		01 		= 0x05
	00 		00 		01 		10 		= 0x06
	00 		00 		10 		00 		= 0x08
	00 		00 		10 		01 		= 0x09
	00 		00 		10 		10 		= 0x0A
	00 		01 		00 		00 		= 0x10
	00 		01 		00 		01 		= 0x11 
	00 		01 		00 		10 		= 0x12
	00 		01 		01 		00 		= 0x14
	00 		01 		01 		01 		= 0x15
	00 		01 		01 		10 		= 0x16
	00 		01 		10 		00 		= 0x18
	00 		01 		10 		01 		= 0x19
	00 		01 		10 		10 		= 0x1A
	00 		10 		00 		00 		= 0x20
	00 		10 		00 		01 		= 0x21
	00 		10 		00 		10 		= 0x22 
	00 		10 		01 		00 		= 0x24
	00 		10 		01 		01 		= 0x25
	00 		10 		01 		10 		= 0x26
	00 		10 		10 		00 		= 0x28
	00 		10 		10 		01 		= 0x29
	00 		10 		10 		10 		= 0x2A
	01 		00 		00 		00 		= 0x40
	01 		00 		00 		01 		= 0x41
	01 		00 		00 		10 		= 0x42
	01 		00 		01 		00 		= 0x44
	01 		00 		01 		01 		= 0x45
	01 		00 		01 		10 		= 0x46
	01 		00 		10 		00 		= 0x48
	01 		00 		10 		01 		= 0x49
	01 		00 		10 		10 		= 0x4A
	01 		01 		00 		00 		= 0x50
	01 		01 		00 		01 		= 0x51
	01 		01 		00 		10 		= 0x52
	01 		01 		01 		00 		= 0x54
	01 		01 		01 		01 		= 0x55
	01 		01 		01 		10 		= 0x56
	01 		01 		10 		00 		= 0x58
	01 		01 		10 		01 		= 0x59
	01 		01 		10 		10 		= 0x5A
	01 		10 		00 		00 		= 0x60
	01 		10 		00 		01 		= 0x61
	01 		10 		00 		10 		= 0x62
	01 		10 		01 		00 		= 0x64
	01 		10 		01 		01 		= 0x65
	01 		10 		01 		10 		= 0x66
	01 		10 		10 		00 		= 0x68
	01 		10 		10 		01 		= 0x69
	01 		10 		10 		10 		= 0x6A
*/


#include <stdarg.h>
#include <ctype.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include "lcd.h"
#include <stdio.h>

void switches(void);
void output(void);
extern void program_run(void);
void program_menu(void);
void output2(void);
void set_display(void);

unsigned char inreg;
long int program_mode;

extern int pgmnum;
extern int fan, heat, cool, off;
extern long int second, delays, delaysa;
extern float Temperature, targettemp;
extern unsigned char mode[10],status[10];


void switches(void)
{
	inreg = ~PIND;

	if(inreg == 0x00)		//00 00 00 00 = 0x00
	{
		pgmnum = 2;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x01)	//00 00 00 01 = 0x01
	{
		pgmnum = 2;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x02)	//00 00 00 10 = 0x02
	{
		pgmnum = 2;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}

	else if(inreg == 0x04)	//00 00 01 00 = 0x04
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x05)	//00 00 01 01 = 0x05
	{
		pgmnum = 1;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x06)	//00 00 01 10 = 0x06
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x08)	//00 00 10 00 = 0x08
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x09)	//00 00 10 01 = 0x09
	{
		pgmnum = 3;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x0A)	//00 00 10 10 = 0x0A
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x10)	//00 01 00 00 = 0x10
	{
		pgmnum = 0;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x11)	//00 01 00 01 = 0x11 
	{
		pgmnum = 2;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x12)	//00 01 00 10 = 0x12
	{
		pgmnum = 2;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x14)	//00 01 01 00 = 0x14
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x15)	//00 01 01 01 = 0x15
	{
		pgmnum = 1;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x16)	//00 01 01 10 = 0x16
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x18)	//00 01 10 00 = 0x18
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x19)	//00 01 10 01 = 0x19
	{
		pgmnum = 3;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x1A)	//00 01 10 10 = 0x1A
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();	
	}

///////////////////////////////////////////////////////////////////
//
//	from here down to the next line of slashes, a program is running
//	we need to decide how we are going to set the heat setting
//	perhaps just sending it to another function that runs the program
//
//

	else if(inreg == 0x20)	//00 10 00 00 = 0x20
	{	
		pgmnum = 2;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x21)	//00 10 00 01 = 0x21
	{
		pgmnum = 2;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x22)	//00 10 00 10 = 0x22 
	{
		pgmnum = 2;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();	
	}
	
	else if(inreg == 0x24)	//00 10 01 00 = 0x24
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x25)	//00 10 01 01 = 0x25
	{
		pgmnum = 1;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x26)	//00 10 01 10 = 0x26
	{
		pgmnum = 1;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x28)	//00 10 10 00 = 0x28
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x29)	//00 10 10 01 = 0x29
	{
		pgmnum = 3;
		fan = 0;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x2A)	//00 10 10 10 = 0x2A
	{
		pgmnum = 3;
		fan = 0;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	else if(inreg == 0x40)	//01 00 00 00 = 0x40
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x41)	//01 00 00 01 = 0x41
	{
		pgmnum = 2;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x42)	//01 00 00 10 = 0x42
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x44)	//01 00 01 00 = 0x44
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x45)	//01 00 01 01 = 0x45
	{
		pgmnum = 1;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x46)	//01 00 01 10 = 0x46
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x48)	//01 00 10 00 = 0x48
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x49)	//01 00 10 01 = 0x49
	{
		pgmnum = 3;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x4A)	//01 00 10 10 = 0x4A
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 0;
		set_display();
	}
	
	else if(inreg == 0x50)	//01 01 00 00 = 0x50
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x51)	//01 01 00 01 = 0x51
	{
		pgmnum = 2;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x52)	//01 01 00 10 = 0x52
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;	
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x54)	//01 01 01 00 = 0x54
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x55)	//01 01 01 01 = 0x55
	{
		pgmnum = 1;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x56)	//01 01 01 10 = 0x56
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x58)	//01 01 10 00 = 0x58
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x59)	//01 01 10 01 = 0x59
	{
		pgmnum = 3;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}
	
	else if(inreg == 0x5A)	//01 01 10 10 = 0x5A
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 1;
		set_display();
		program_menu();
	}

///////////////////////////////////////////////////////////////////
//
//	from here down to the next line of slashes, a program is running
//	we need to decide how we are going to set the heat setting
//	perhaps just sending it to another function that runs the program
//
//

	else if(inreg == 0x60)	//01 10 00 00 = 0x60
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x61)	//01 10 00 01 = 0x61
	{
		pgmnum = 2;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x62)	//01 10 00 10 = 0x62
	{
		pgmnum = 2;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x64)	//01 10 01 00 = 0x64
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x65)	//01 10 01 01 = 0x65
	{
		pgmnum = 1;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x66)	//01 10 01 10 = 0x66
	{
		pgmnum = 1;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x68)	//01 10 10 00 = 0x68
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 0;
		off = 1;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x69)	//01 10 10 01 = 0x69
	{
		pgmnum = 3;
		fan = 1;
		cool = 1;
		heat = 0;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}
	
	else if(inreg == 0x6A)	//01 10 10 10 = 0x6A
	{
		pgmnum = 3;
		fan = 1;
		cool = 0;
		heat = 1;
		off = 0;
		program_mode = 3;
		set_display();
		program_run();
	}

	output2();  //sets the LEDs

//////////////////////////////////////////////////////////////////////////////////////////////////////

}


// sets up outputs so that when the output should be on the voltage will drop
// set up opposite because of program (ex. 0xFD = 0x05)

void output(void)
{
	if(heat == 1 && cool == 0)
	{
		outp(0x02, PORTB);
	}
	
	else if(heat == 0 && cool == 1)
	{
		outp(0x04, PORTB);
	}

	else if(heat == 0 && cool == 0 && fan == 1)
	{
		outp(0x06, PORTB);
	}
	
	else if(heat == 0 && cool == 0 && fan == 0)
	{
		outp(0x07, PORTB);
	}
	
	return;
}


///if the program_mode == 0 then this should be ran,


void output2(void)
{
	if(heat == 1 && cool == 0 && fan == 1)
	{
		if(Temperature < (targettemp - 1))
		{
			outp(0x02,PORTB);
		}
		else
		{
			outp(0x06,PORTB);
		}
	}

	else if(heat == 1 && cool == 0 && fan == 0)
	{
		if(Temperature < (targettemp - 1))
		{
			outp(0x02,PORTB);
		}
		else
		{
			outp(0x07,PORTB);
		}
	}

	else if(heat == 0 && cool == 1 && fan == 1)
	{
		if(Temperature > (targettemp + 1))
		{
			outp(0x04,PORTB);
		}
		else
		{
			outp(0x06,PORTB);
		}
	}

	else if(heat == 0 && cool == 1 && fan == 0)
	{
		if(Temperature > (targettemp + 1))
		{
			outp(0x04,PORTB);
		}
		else
		{
			outp(0x07,PORTB);
		}
	}
	
	else if(heat == 0 && cool == 0 && fan == 1)
	{
		outp(0x06, PORTB);
	}
	
	else if(fan == 0 && heat == 0 && cool == 0)
	{
		outp(0x07, PORTB);
	}	
}

void set_display(void)
{
	if (fan == 1)
	{
		strcpy(mode, "ON  ");
	}
	
	else if (fan == 0)
	{
		strcpy(mode, "AUTO");
	}
	
	if (heat == 1)
	{
		strcpy(status, "HEAT");
	}
	else if (off == 1)
	{
		strcpy(status, "OFF ");
	}
	else if (cool == 1)
	{
		strcpy(status, "COOL");
	}
	return;
}
